From 98ce94864fdb13f0679a92efebea73c64bf6e64f Mon Sep 17 00:00:00 2001
From: Rishu Bagga <bagrishu@amazon.com>
Date: Tue, 20 Jun 2023 21:38:19 +0000
Subject: [PATCH 3/4] slru_to_buf_keep_slru_use_nrels

---
 src/backend/access/transam/Makefile           |    1 +
 src/backend/access/transam/clog.c             |   23 +-
 src/backend/access/transam/commit_ts.c        |   36 +-
 src/backend/access/transam/multixact.c        |   58 +-
 src/backend/access/transam/nrel.c             |  722 +++++++
 src/backend/access/transam/slru.c             | 1739 +++++++++++++----
 src/backend/access/transam/subtrans.c         |   18 +-
 src/backend/access/transam/xact.c             |   15 +-
 src/backend/access/transam/xlog.c             |    2 +-
 src/backend/commands/async.c                  |   27 +-
 src/backend/storage/lmgr/predicate.c          |   16 +-
 src/backend/storage/smgr/smgr.c               |   22 +-
 src/backend/storage/sync/sync.c               |    5 +-
 src/backend/utils/activity/pgstat_slru.c      |   12 +-
 .../utils/activity/wait_event_names.txt       |    4 +
 src/backend/utils/adt/pgstatfuncs.c           |   15 +-
 src/include/access/nrel.h                     |  112 ++
 src/include/access/slru.h                     |  204 +-
 src/include/pgstat.h                          |    4 +-
 src/include/storage/smgr.h                    |    4 +-
 src/include/storage/sync.h                    |    3 +-
 src/include/utils/memutils.h                  |    1 -
 src/include/utils/pgstat_internal.h           |    5 +-
 23 files changed, 2449 insertions(+), 599 deletions(-)
 create mode 100644 src/backend/access/transam/nrel.c
 create mode 100644 src/include/access/nrel.h

diff --git a/src/backend/access/transam/Makefile b/src/backend/access/transam/Makefile
index 661c55a9db7..0fb2114f44e 100644
--- a/src/backend/access/transam/Makefile
+++ b/src/backend/access/transam/Makefile
@@ -17,6 +17,7 @@ OBJS = \
 	commit_ts.o \
 	generic_xlog.o \
 	multixact.o \
+	nrel.o \
 	parallel.o \
 	rmgr.o \
 	slru.o \
diff --git a/src/backend/access/transam/clog.c b/src/backend/access/transam/clog.c
index ec226ffd7e8..88a275f5823 100644
--- a/src/backend/access/transam/clog.c
+++ b/src/backend/access/transam/clog.c
@@ -34,6 +34,7 @@
 
 #include "access/clog.h"
 #include "access/slru.h"
+#include "access/nrel.h"
 #include "access/transam.h"
 #include "access/xlog.h"
 #include "access/xloginsert.h"
@@ -44,6 +45,7 @@
 #include "storage/bufmgr.h"
 #include "storage/buf_internals.h"
 #include "storage/proc.h"
+#include "storage/smgr.h"
 #include "storage/sync.h"
 
 /*
@@ -350,7 +352,7 @@ TransactionIdSetPageStatusInternal(TransactionId xid, int nsubxids,
 	 * write-busy, since we don't care if the update reaches disk sooner than
 	 * we think.
 	 */
-	buffer = ReadSlruBuffer(SLRU_CLOG_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_CLOG_REL_ID, pageno);
 	LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 
 	/*
@@ -641,7 +643,7 @@ TransactionIdGetStatus(TransactionId xid, XLogRecPtr *lsn)
 	XidStatus	status;
 	Buffer		buffer;
 
-	buffer = ReadSlruBuffer(SLRU_CLOG_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_CLOG_REL_ID, pageno);
 	byteptr = BufferGetPage(buffer) + byteno;
 
 	status = (*byteptr >> bshift) & CLOG_XACT_BITMASK;
@@ -687,7 +689,8 @@ ZeroCLOGPage(int pageno, bool writeXlog)
 {
 	Buffer		buffer;
 
-	buffer = ZeroSlruBuffer(SLRU_CLOG_REL_ID, pageno);
+	buffer = ZeroNrelBuffer(NREL_CLOG_REL_ID, pageno);
+
 	MarkBufferDirty(buffer);
 
 	if (writeXlog)
@@ -733,7 +736,8 @@ TrimCLOG(void)
 		char	   *byteptr;
 		Buffer		buffer;
 
-		buffer = ReadSlruBuffer(SLRU_CLOG_REL_ID, pageno);
+		buffer = ReadNrelBuffer(NREL_CLOG_REL_ID, pageno);
+
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 		byteptr = BufferGetPage(buffer) + byteno;
 
@@ -798,13 +802,13 @@ TruncateCLOG(TransactionId oldestXact, Oid oldestxid_datoid)
 
 	/*
 	 * The cutoff point is the start of the segment containing oldestXact. We
-	 * pass the *page* containing oldestXact to SimpleLruTruncate.
+	 * pass the *page* containing oldestXact to NonRelTruncate.
 	 */
 	cutoffPage = TransactionIdToPage(oldestXact);
 
 	/* Check to see if there's any files that could be removed */
-	if (!SlruScanDirectory(SLRU_CLOG_REL_ID, CLOGPagePrecedes,
-						   SlruScanDirCbReportPresence, &cutoffPage))
+	if (!NrelScanDirectory(NREL_CLOG_REL_ID, CLOGPagePrecedes,
+						   NrelScanDirCbReportPresence, &cutoffPage))
 		return;					/* nothing to remove */
 
 	/*
@@ -825,10 +829,11 @@ TruncateCLOG(TransactionId oldestXact, Oid oldestxid_datoid)
 	WriteTruncateXlogRec(cutoffPage, oldestXact, oldestxid_datoid);
 
 	/* Now we can remove the old CLOG segment(s) */
-	SimpleLruTruncate(SLRU_CLOG_REL_ID, CLOGPagePrecedes, cutoffPage);
+	NonRelTruncate(NREL_CLOG_REL_ID, CLOGPagePrecedes, cutoffPage);
 }
 
 
+
 /*
  * Decide whether a CLOG page number is "older" for truncation purposes.
  *
@@ -939,7 +944,7 @@ clog_redo(XLogReaderState *record)
 
 		AdvanceOldestClogXid(xlrec.oldestXact);
 
-		SimpleLruTruncate(SLRU_CLOG_REL_ID, CLOGPagePrecedes, xlrec.pageno);
+		NonRelTruncate(NREL_CLOG_REL_ID, CLOGPagePrecedes, xlrec.pageno);
 	}
 	else
 		elog(PANIC, "clog_redo: unknown op code %u", info);
diff --git a/src/backend/access/transam/commit_ts.c b/src/backend/access/transam/commit_ts.c
index 3d8af7b9609..6cb2870e5f4 100644
--- a/src/backend/access/transam/commit_ts.c
+++ b/src/backend/access/transam/commit_ts.c
@@ -23,6 +23,7 @@
 
 #include "access/commit_ts.h"
 #include "access/htup_details.h"
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/transam.h"
 #include "access/xloginsert.h"
@@ -51,7 +52,7 @@
 /*
  * We need 8+2 bytes per xact.  Note that enlarging this struct might mean
  * the largest possible file name is more than 5 chars long; see
- * SlruScanDirectory.
+ * NrelScanDirectory.
  */
 typedef struct CommitTimestampEntry
 {
@@ -212,7 +213,8 @@ SetXidCommitTsInPage(TransactionId xid, int nsubxids,
 	int			i;
 	Buffer		buffer;
 
-	buffer = ReadSlruBuffer(SLRU_COMMITTS_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_COMMITTS_REL_ID, pageno);
+
 	LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 
 	TransactionIdSetCommitTs(xid, ts, nodeid, buffer);
@@ -314,7 +316,8 @@ TransactionIdGetCommitTsData(TransactionId xid, TimestampTz *ts,
 		return false;
 	}
 
-	buffer = ReadSlruBuffer(SLRU_COMMITTS_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_COMMITTS_REL_ID, pageno);
+
 	LockBuffer(buffer, BUFFER_LOCK_SHARE);
 
 	memcpy(&entry,
@@ -495,7 +498,7 @@ CommitTsShmemInit(void)
 {
 	bool		found;
 
-	SlruPagePrecedesUnitTests(CommitTsPagePrecedes, COMMIT_TS_XACTS_PER_PAGE);
+	NrelPagePrecedesUnitTests(CommitTsPagePrecedes, COMMIT_TS_XACTS_PER_PAGE);
 
 	commitTsShared = ShmemInitStruct("CommitTs shared",
 									 sizeof(CommitTimestampShared),
@@ -544,7 +547,8 @@ ZeroCommitTsPage(int pageno, bool writeXlog)
 {
 	Buffer		buffer;
 
-	buffer = ZeroSlruBuffer(SLRU_COMMITTS_REL_ID, pageno);
+	buffer = ZeroNrelBuffer(NREL_COMMITTS_REL_ID, pageno);
+
 	MarkBufferDirty(buffer);
 
 	if (writeXlog)
@@ -670,11 +674,12 @@ ActivateCommitTs(void)
 	LWLockRelease(CommitTsLock);
 
 	/* Create the current segment file, if necessary */
-	if (!SimpleLruDoesPhysicalPageExist(SLRU_COMMITTS_REL_ID, pageno))
+	if (!NonRelDoesPhysicalPageExist(NREL_COMMITTS_REL_ID, pageno))
 	{
 		Buffer		buffer;
 
-		buffer = ZeroSlruBuffer(SLRU_COMMITTS_REL_ID, pageno);
+		buffer = ZeroNrelBuffer(NREL_COMMITTS_REL_ID, pageno);
+
 		MarkBufferDirty(buffer);
 		FlushOneBuffer(buffer);
 		UnlockReleaseBuffer(buffer);
@@ -726,9 +731,9 @@ DeactivateCommitTs(void)
 	 * be overwritten anyway when we wrap around, but it seems better to be
 	 * tidy.)
 	 */
-	(void) SlruScanDirectory(SLRU_COMMITTS_REL_ID,
+	(void) NrelScanDirectory(NREL_COMMITTS_REL_ID,
 							 CommitTsPagePrecedes,
-							 SlruScanDirCbDeleteAll, NULL);
+							 NrelScanDirCbDeleteAll, NULL);
 }
 
 /*
@@ -783,14 +788,14 @@ TruncateCommitTs(TransactionId oldestXact)
 
 	/*
 	 * The cutoff point is the start of the segment containing oldestXact. We
-	 * pass the *page* containing oldestXact to SimpleLruTruncate.
+	 * pass the *page* containing oldestXact to NonRelTruncate.
 	 */
 	cutoffPage = TransactionIdToCTsPage(oldestXact);
 
 	/* Check to see if there's any files that could be removed */
-	if (!SlruScanDirectory(SLRU_COMMITTS_REL_ID,
+	if (!NrelScanDirectory(NREL_COMMITTS_REL_ID,
 						   CommitTsPagePrecedes,
-						   SlruScanDirCbReportPresence,
+						   NrelScanDirCbReportPresence,
 						   &cutoffPage))
 		return;					/* nothing to remove */
 
@@ -798,7 +803,7 @@ TruncateCommitTs(TransactionId oldestXact)
 	WriteTruncateXlogRec(cutoffPage, oldestXact);
 
 	/* Now we can remove the old CommitTs segment(s) */
-	SimpleLruTruncate(SLRU_COMMITTS_REL_ID, CommitTsPagePrecedes, cutoffPage);
+	NonRelTruncate(NREL_COMMITTS_REL_ID, CommitTsPagePrecedes, cutoffPage);
 }
 
 /*
@@ -926,7 +931,8 @@ commit_ts_redo(XLogReaderState *record)
 
 		memcpy(&pageno, XLogRecGetData(record), sizeof(int));
 
-		buffer = ZeroSlruBuffer(SLRU_COMMITTS_REL_ID, pageno);
+		buffer = ZeroNrelBuffer(NREL_COMMITTS_REL_ID, pageno);
+
 		MarkBufferDirty(buffer);
 		FlushOneBuffer(buffer);
 		UnlockReleaseBuffer(buffer);
@@ -937,7 +943,7 @@ commit_ts_redo(XLogReaderState *record)
 
 		AdvanceOldestCommitTsXid(trunc->oldestXid);
 
-		SimpleLruTruncate(SLRU_COMMITTS_REL_ID, CommitTsPagePrecedes, trunc->pageno);
+		NonRelTruncate(NREL_COMMITTS_REL_ID, CommitTsPagePrecedes, trunc->pageno);
 	}
 	else
 		elog(PANIC, "commit_ts_redo: unknown op code %u", info);
diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
index 9d7b2e1ce94..810aec99a49 100644
--- a/src/backend/access/transam/multixact.c
+++ b/src/backend/access/transam/multixact.c
@@ -69,6 +69,7 @@
 #include "postgres.h"
 
 #include "access/multixact.h"
+#include "access/nrel.h"
 #include "access/slru.h"
 #include "access/transam.h"
 #include "access/twophase.h"
@@ -873,7 +874,8 @@ RecordNewMultiXact(MultiXactId multi, MultiXactOffset offset,
 	if (offset_buf_ptr)
 		offset_buf = *offset_buf_ptr;
 	else 
-		offset_buf = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_ID, pageno);
+		offset_buf = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 
 	LockBuffer(offset_buf, BUFFER_LOCK_EXCLUSIVE);
 						
@@ -917,7 +919,8 @@ RecordNewMultiXact(MultiXactId multi, MultiXactOffset offset,
 			if (member_bufs)
 				buffer = member_bufs[pageno - min_pageno];
 			else
-				buffer = ReadSlruBuffer(SLRU_MULTIXACT_MEMBER_ID, pageno);
+				buffer = ReadNrelBuffer(NREL_MULTIXACT_MEMBER_REL_ID, pageno);
+
 
 			LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 			prev_pageno = pageno;
@@ -1363,7 +1366,8 @@ retry:
 	pageno = MultiXactIdToOffsetPage(multi);
 	entryno = MultiXactIdToOffsetEntry(multi);
 
-	buffer = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 	LockBuffer(buffer, BUFFER_LOCK_SHARE);
 	offptr = (MultiXactOffset *) BufferGetPage(buffer);
 	offptr += entryno;
@@ -1398,7 +1402,8 @@ retry:
 		if (pageno != prev_pageno)
 		{
 			UnlockReleaseBuffer(buffer);
-			buffer = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_REL_ID, pageno);
+			buffer = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 			LockBuffer(buffer, BUFFER_LOCK_SHARE);
 		}
 
@@ -1439,7 +1444,8 @@ retry:
 		{
 			if (BufferIsValid(buffer))
 				UnlockReleaseBuffer(buffer);
-			buffer = ReadSlruBuffer(SLRU_MULTIXACT_MEMBER_REL_ID, pageno);
+			buffer = ReadNrelBuffer(NREL_MULTIXACT_MEMBER_REL_ID, pageno);
+
 			LockBuffer(buffer, BUFFER_LOCK_SHARE);
 			prev_pageno = pageno;
 		}
@@ -1921,7 +1927,8 @@ ZeroMultiXactOffsetPage(int pageno, bool writeXlog)
 {
 	Buffer		buffer;
 
-	buffer = ZeroSlruBuffer(SLRU_MULTIXACT_OFFSET_REL_ID, pageno);
+	buffer = ZeroNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 	MarkBufferDirty(buffer);
 
 	if (writeXlog)
@@ -1938,7 +1945,8 @@ ZeroMultiXactMemberPage(int pageno, bool writeXlog)
 {
 	Buffer		buffer;
 
-	buffer = ZeroSlruBuffer(SLRU_MULTIXACT_MEMBER_REL_ID, pageno);
+	buffer = ZeroNrelBuffer(NREL_MULTIXACT_MEMBER_REL_ID, pageno);
+
 	MarkBufferDirty(buffer);
 
 	if (writeXlog)
@@ -1969,7 +1977,7 @@ MaybeExtendOffsetSlru(void)
 
 	pageno = MultiXactIdToOffsetPage(MultiXactState->nextMXact);
 
-	if (!SimpleLruDoesPhysicalPageExist(SLRU_MULTIXACT_OFFSET_REL_ID, pageno))
+	if (!NonRelDoesPhysicalPageExist(NREL_MULTIXACT_OFFSET_REL_ID, pageno))
 	{
 		Buffer			buffer;
 
@@ -2030,7 +2038,8 @@ TrimMultiXact(void)
 		MultiXactOffset *offptr;
 		Buffer		buffer;
 
-		buffer = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_REL_ID, pageno);
+		buffer = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 		offptr = (MultiXactOffset *) BufferGetPage(buffer);
 		offptr += entryno;
@@ -2055,7 +2064,8 @@ TrimMultiXact(void)
 		Buffer		buffer;
 
 		memberoff = MXOffsetToMemberOffset(offset);
-		buffer = ReadSlruBuffer(SLRU_MULTIXACT_MEMBER_REL_ID, pageno);
+		buffer = ReadNrelBuffer(NREL_MULTIXACT_MEMBER_REL_ID, pageno);
+
 		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
 		xidptr = (TransactionId *) (BufferGetPage(buffer) + memberoff);
 
@@ -2352,7 +2362,7 @@ ExtendMultiXactOffset(MultiXactId multi, Buffer * buffer)
 		multi != FirstMultiXactId)
 	{
 		/* make a read buffer call to enlarge the resource owner */
-		*buffer = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_ID, pageno);
+		*buffer = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
 		return;
 	} else
 	{
@@ -2408,7 +2418,8 @@ ExtendMultiXactMember(MultiXactOffset offset, int nmembers, Buffer ** buffers)
 		} else
 		{
 			/* do a read buffer call to allocate space beforehand */
-			buf = ReadSlruBuffer(SLRU_MULTIXACT_MEMBER_ID, pageno);
+			buf = ReadNrelBuffer(NREL_MULTIXACT_MEMBER_REL_ID, pageno);
+
 		}
 
 		if (buffers)
@@ -2689,7 +2700,7 @@ find_multixact_start(MultiXactId multi, MultiXactOffset *result)
 	int			entryno;
 	MultiXactOffset *offptr;
 	Buffer		buffer;
-	RelFileLocator rlocator = SlruRelFileLocator(SLRU_MULTIXACT_OFFSET_REL_ID);
+	RelFileLocator rlocator = NrelRelFileLocator(NREL_MULTIXACT_OFFSET_REL_ID);
 
 	Assert(MultiXactState->finishedStartup);
 
@@ -2701,10 +2712,11 @@ find_multixact_start(MultiXactId multi, MultiXactOffset *result)
 	 * commit 068cfadf9).
 	 */
 	if (!BufferProbe(rlocator, MAIN_FORKNUM, pageno) &&
-		!SimpleLruDoesPhysicalPageExist(SLRU_MULTIXACT_OFFSET_REL_ID, pageno))
+		!NonRelDoesPhysicalPageExist(NREL_MULTIXACT_OFFSET_REL_ID, pageno))
 		return false;
 
-	buffer = ReadSlruBuffer(SLRU_MULTIXACT_OFFSET_REL_ID, pageno);
+	buffer = ReadNrelBuffer(NREL_MULTIXACT_OFFSET_REL_ID, pageno);
+
 	LockBuffer(buffer, BUFFER_LOCK_SHARE);
 	offptr = (MultiXactOffset *) BufferGetPage(buffer);
 	offptr += entryno;
@@ -2812,7 +2824,7 @@ typedef struct mxtruncinfo
  *		This callback determines the earliest existing page number.
  */
 static bool
-SlruScanDirCbFindEarliest(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
+NrelScanDirCbFindEarliest(Oid rel_id, NrelPagePrecedesFunction PagePrecedes,
 						  char *filename, int segpage, void *data)
 {
 	mxtruncinfo *trunc = (mxtruncinfo *) data;
@@ -2831,7 +2843,7 @@ SlruScanDirCbFindEarliest(Oid rel_id, SlruPagePrecedesFunction PagePrecedes,
  * Delete members segments [oldest, newOldest)
  *
  * The members SLRU can, in contrast to the offsets one, be filled to almost
- * the full range at once. This means SimpleLruTruncate() can't trivially be
+ * the full range at once. This means NonRelTruncate() can't trivially be
  * used - instead the to-be-deleted range is computed using the offsets
  * SLRU. C.f. TruncateMultiXact().
  */
@@ -2850,7 +2862,7 @@ PerformMembersTruncation(MultiXactOffset oldestOffset, MultiXactOffset newOldest
 	while (segment != endsegment)
 	{
 		elog(DEBUG2, "truncating multixact members segment %x", segment);
-		SlruDeleteSegment(SLRU_MULTIXACT_MEMBER_REL_ID, segment);
+		NrelDeleteSegment(NREL_MULTIXACT_MEMBER_REL_ID, segment);
 
 		/* move to next segment, handling wraparound correctly */
 		if (segment == maxsegment)
@@ -2870,10 +2882,10 @@ PerformOffsetsTruncation(MultiXactId oldestMulti, MultiXactId newOldestMulti)
 	 * We step back one multixact to avoid passing a cutoff page that hasn't
 	 * been created yet in the rare case that oldestMulti would be the first
 	 * item on a page and oldestMulti == nextMulti.  In that case, if we
-	 * didn't subtract one, we'd trigger SimpleLruTruncate's wraparound
+	 * didn't subtract one, we'd trigger NonRelTruncate's wraparound
 	 * detection.
 	 */
-	SimpleLruTruncate(SLRU_MULTIXACT_OFFSET_REL_ID,
+	NonRelTruncate(NREL_MULTIXACT_OFFSET_REL_ID,
 					  MultiXactOffsetPagePrecedes,
 					  MultiXactIdToOffsetPage(PreviousMultiXactId(newOldestMulti)));
 }
@@ -2937,7 +2949,7 @@ TruncateMultiXact(MultiXactId newOldestMulti, Oid newOldestMultiDB)
 	 * the earliest offsets page number that we can read without error.
 	 *
 	 * When nextMXact is less than one segment away from multiWrapLimit,
-	 * SlruScanDirCbFindEarliest can find some early segment other than the
+	 * NrelScanDirCbFindEarliest can find some early segment other than the
 	 * actual earliest.  (MultiXactOffsetPagePrecedes(EARLIEST, LATEST)
 	 * returns false, because not all pairs of entries have the same answer.)
 	 * That can also arise when an earlier truncation attempt failed unlink()
@@ -2948,9 +2960,9 @@ TruncateMultiXact(MultiXactId newOldestMulti, Oid newOldestMultiDB)
 	 * been truncated away, and we crashed before updating oldestMulti.
 	 */
 	trunc.earliestExistingPage = -1;
-	SlruScanDirectory(SLRU_MULTIXACT_OFFSET_REL_ID,
+	NrelScanDirectory(NREL_MULTIXACT_OFFSET_REL_ID,
 					  MultiXactOffsetPagePrecedes,
-					  SlruScanDirCbFindEarliest, &trunc);
+					  NrelScanDirCbFindEarliest, &trunc);
 	earliest = trunc.earliestExistingPage * MULTIXACT_OFFSETS_PER_PAGE;
 	if (earliest < FirstMultiXactId)
 		earliest = FirstMultiXactId;
